{--------------------------------------------------------}

{
{    VoxTube - utilitrio de acessibilizao do YouTube
{
{    Procedimentos de download
{
{    Autor:  Fabiano Ferreira
{
{    Em fevereiro de 2013
{
{--------------------------------------------------------}

unit vtRede;

interface
uses dvcrt, dvwin, dvinet, sysutils;

function stringToURL(s: string): string;
function URLToString(s: string): string;

implementation
uses pipe;

{--------------------------------------------------------}
{   transforma string para a codificao usada em URLs
{--------------------------------------------------------}

function stringToURL(s: string): string;
var i: integer;
begin
    result := '';
    for i := 1 to length(s) do
        begin
            if s[i] in ['0'..'9', 'a'..'z', 'A'..'Z', '.', '-', '_', '~'] then
                result := result + s[i]
            else
                result := result + '%' + intToHex(ord(s[i]), 2);
        end;
end;

{--------------------------------------------------------}
{   transforma string para a codificao usada em URLs
{--------------------------------------------------------}

function URLToString(s: string): string;

    function hex(c: char): integer;
    begin
        if c in ['0'..'9'] then result := ord(c) - ord('0')
        else
        if c in ['a'..'f'] then result := ord(c) - ord('a') + 10
        else
        if c in ['A'..'F'] then result := ord(c) - ord('A') + 10
        else
            result := 0;
    end;

var i, n: integer;

begin
    result := '';
    i := 1;
    while i <= length(s) do
        begin
            if (s[i] = '%') and (i <= length(s)-2) then
                begin
                    n := (hex(s[i+1]) shl 4) + hex(s[i+1]);
                    result := result + chr(n);
                    i := i + 3;
                end
            else
                begin
                    result := result + s[i];
                    i := i + 1;
                end;
        end;
end;

end.
